"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function rndw(items, callback) {
    if (!Array.isArray(items)) {
        throw new TypeError("Items is not array!");
    }
    if (!(callback && callback instanceof Function)) {
        throw new TypeError("callback is not a function!");
    }
    var total = 0;
    for (var i = 0; i < items.length; i++) {
        var w = callback(items[i]);
        if (typeof w != "number") {
            throw new TypeError("callback does not produce number");
        }
        total += w;
    }
    var r = Math.random() * total;
    for (var i = 0; i < items.length; i++) {
        total -= callback(items[i]);
        if (total <= r) {
            return items[i];
        }
    }
    console.warn("random weight fallback to the last item");
    return items[items.length - 1];
}
exports.default = rndw;
//# sourceMappingURL=index.js.map